RecoveryOperation (Oracle - Berkeley DB Java API)
Date: 2020-06-01

Package com.sleepycat.db

## Class RecoveryOperation

- java.lang.Object
- - com.sleepycat.db.RecoveryOperation

-     public final class RecoveryOperation
      extends java.lang.Object

  The recovery operation being performed when `LogRecordHandler.handleLogRecord` is called.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static RecoveryOperation` | `ABORT` | The log is being read backward during a transaction abort; undo the operation described by the log record.
    `static RecoveryOperation` | `APPLY` | The log is being applied on a replica site; redo the operation described by the log record.
    `static RecoveryOperation` | `BACKWARD_ROLL` | The log is being read backward to determine which transactions have been committed and to abort those operations that were not; undo the operation described by the log record.
    `static RecoveryOperation` | `FORWARD_ROLL` | The log is being played forward; redo the operation described by the log record.
    `static RecoveryOperation` | `PRINT` | The log is being printed for debugging purposes; print the contents of this log record in the desired format.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static RecoveryOperation` | `fromFlag​(int flag)` | Internal: this is public only so it can be called from an internal package.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### BACKWARD_ROLL

          public static final RecoveryOperation BACKWARD_ROLL

      The log is being read backward to determine which transactions have been committed and to abort those operations that were not; undo the operation described by the log record.

    - #### FORWARD_ROLL

          public static final RecoveryOperation FORWARD_ROLL

      The log is being played forward; redo the operation described by the log record.

      The FORWARD_ROLL and APPLY operations frequently imply the same actions, redoing changes that appear in the log record, although if a recovery function is to be used on a replication client where reads may be taking place concurrently with the processing of incoming messages, APPLY operations should also perform appropriate locking.

    - #### ABORT

          public static final RecoveryOperation ABORT

      The log is being read backward during a transaction abort; undo the operation described by the log record.

    - #### APPLY

          public static final RecoveryOperation APPLY

      The log is being applied on a replica site; redo the operation described by the log record.

      The FORWARD_ROLL and APPLY operations frequently imply the same actions, redoing changes that appear in the log record, although if a recovery function is to be used on a replication client where reads may be taking place concurrently with the processing of incoming messages, APPLY operations should also perform appropriate locking.

    - #### PRINT

          public static final RecoveryOperation PRINT

      The log is being printed for debugging purposes; print the contents of this log record in the desired format.

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### fromFlag

          public static RecoveryOperation fromFlag​(int flag)

      Internal: this is public only so it can be called from an internal package.
      Parameters:
        `flag` - the internal flag value to be wrapped in a RecoveryException object
      Returns:
        a RecoveryOperation

Copyright (c) 1996, 2020 Oracle and/or its affiliates. All rights reserved.